Index: cpukit/ChangeLog
===================================================================
--- cpukit/ChangeLog	(revision ce57509cbd075f55a682c6b8730f1440b03ddf0c)
+++ cpukit/ChangeLog	(revision b311cbc9577a2606db5f7cdb691f99d680dc9fc1)
@@ -1,2 +1,10 @@
+2009-06-17	Chris Johns <chrisj@rtems.org>
+
+	* libmisc/shell/extern-dd.h: Delcare the conv arrays extern to
+	stop PPC link errors.
+	* libmisc/shell/main_time.c, libmisc/Makefile.am,
+	libmisc/shell/shellconfig.h: Add a time command.
+	
+	* libmisc/shell/shellconfig.h, 
 2009-06-16	Joel Sherrill <joel.sherrill@oarcorp.com>
 
Index: cpukit/libmisc/Makefile.am
===================================================================
--- cpukit/libmisc/Makefile.am	(revision ce57509cbd075f55a682c6b8730f1440b03ddf0c)
+++ cpukit/libmisc/Makefile.am	(revision b311cbc9577a2606db5f7cdb691f99d680dc9fc1)
@@ -91,5 +91,6 @@
     shell/dd-position.c \
     shell/main_hexdump.c shell/hexdump-conv.c shell/hexdump-display.c \
-    shell/hexdump-odsyntax.c shell/hexdump-parse.c shell/hexsyntax.c
+    shell/hexdump-odsyntax.c shell/hexdump-parse.c shell/hexsyntax.c \
+    shell/main_time.c
 
 if LIBNETWORKING
Index: cpukit/libmisc/shell/extern-dd.h
===================================================================
--- cpukit/libmisc/shell/extern-dd.h	(revision ce57509cbd075f55a682c6b8730f1440b03ddf0c)
+++ cpukit/libmisc/shell/extern-dd.h	(revision b311cbc9577a2606db5f7cdb691f99d680dc9fc1)
@@ -96,7 +96,7 @@
 void unblock_close(rtems_shell_dd_globals* globals);
 
-const u_char a2e_32V[256], a2e_POSIX[256];
-const u_char e2a_32V[256], e2a_POSIX[256];
-const u_char a2ibm_32V[256], a2ibm_POSIX[256];
+extern const u_char a2e_32V[256], a2e_POSIX[256];
+extern const u_char e2a_32V[256], e2a_POSIX[256];
+extern const u_char a2ibm_32V[256], a2ibm_POSIX[256];
 
 void rtems_shell_dd_exit(rtems_shell_dd_globals* globals, int code);
Index: cpukit/libmisc/shell/main_time.c
===================================================================
--- cpukit/libmisc/shell/main_time.c	(revision b311cbc9577a2606db5f7cdb691f99d680dc9fc1)
+++ cpukit/libmisc/shell/main_time.c	(revision b311cbc9577a2606db5f7cdb691f99d680dc9fc1)
@@ -0,0 +1,84 @@
+/*
+ *  Time Shell Command Implmentation
+ *
+ *  Author: Chris Johns <chrisj@rtems.org>
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ *
+ *  $Id$
+ */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <stdio.h>
+#include <unistd.h>
+#include <string.h>
+#include <errno.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+
+#include <rtems.h>
+#include <rtems/shell.h>
+#include "internal.h"
+
+int rtems_shell_main_time(
+  int   argc,
+  char *argv[]
+)
+{
+  rtems_shell_cmd_t* shell_cmd;
+  int                errorlevel = 0;
+  struct timespec    start;
+  struct timespec    end;
+  struct timespec    period;
+  rtems_status_code  sc;
+
+  argc--;
+
+  sc = rtems_clock_get_uptime(&start);
+  if (sc != RTEMS_SUCCESSFUL)
+    printf("error: cannot read time\n");
+  
+  if (argc) {
+    shell_cmd = rtems_shell_lookup_cmd(argv[1]);
+    if ( argv[1] == NULL ) {
+      errorlevel = -1;
+    } else if ( shell_cmd == NULL ) {
+      errorlevel = rtems_shell_script_file(argc, &argv[1]);
+    } else {
+      errorlevel = shell_cmd->command(argc, &argv[1]);
+    }
+  }
+
+  sc = rtems_clock_get_uptime(&end);
+  if (sc != RTEMS_SUCCESSFUL)
+    printf("error: cannot read time\n");
+
+  period.tv_sec = end.tv_sec - start.tv_sec;
+  period.tv_nsec = end.tv_nsec - start.tv_nsec;
+  if (period.tv_nsec < 0)
+  {
+    --period.tv_sec;
+    period.tv_nsec += 1000000000UL;
+  }
+  
+  printf("time: %li:%02li:%02li.%03li\n",
+         period.tv_sec / 3600,
+         period.tv_sec / 60, period.tv_sec % 60,
+         period.tv_nsec / 1000000);
+  
+  return errorlevel;
+}
+
+rtems_shell_cmd_t rtems_shell_TIME_Command = {
+  "time",                                     /* name */
+  "time command [arguments...]",              /* usage */
+  "misc",                                     /* topic */
+  rtems_shell_main_time,                      /* command */
+  NULL,                                       /* alias */
+  NULL                                        /* next */
+};
Index: cpukit/libmisc/shell/shellconfig.h
===================================================================
--- cpukit/libmisc/shell/shellconfig.h	(revision ce57509cbd075f55a682c6b8730f1440b03ddf0c)
+++ cpukit/libmisc/shell/shellconfig.h	(revision b311cbc9577a2606db5f7cdb691f99d680dc9fc1)
@@ -22,4 +22,5 @@
 extern rtems_shell_cmd_t rtems_shell_HELP_Command;
 extern rtems_shell_cmd_t rtems_shell_ALIAS_Command;
+extern rtems_shell_cmd_t rtems_shell_TIME_Command;
 extern rtems_shell_cmd_t rtems_shell_LOGOFF_Command;
 
@@ -148,4 +149,5 @@
     &rtems_shell_HELP_Command,
     &rtems_shell_ALIAS_Command,
+    &rtems_shell_TIME_Command,
 
     /*
